=== debian/changelog ===
flashrom (0.9.7+r1782-1) unstable; urgency=high

  * New upstream release (Closes: #746734, #690478).
  * debian/compat: Upgrade from 5 to 9.
  * Standards-Version: 3.9.5 (no changes required).

 -- Uwe Hermann <uwe@debian.org>  Sat, 03 May 2014 17:39:35 +0200
