## flashrom 0.9.9+r1954

=== Makefile ===
--- 
+++ 
@@ -314,7 +314,7 @@
 else
 override CONFIG_PONY_SPI = no
 endif
-# Dediprog, USB-Blaster, PICkit2, CH341A and FT2232 are not supported with libpayload (missing libusb support)
+# Dediprog, USB-Blaster, PICkit2, CH341A and FT2232 are not supported with libpayload (missing libusb support).
 ifeq ($(CONFIG_DEDIPROG), yes)
 UNSUPPORTED_FEATURES += CONFIG_DEDIPROG=yes
 else
@@ -343,6 +343,8 @@
 endif
 
 ifneq ($(TARGET_OS), Linux)
+# Android is handled internally as separate OS, but it supports CONFIG_LINUX_SPI and CONFIG_MSTARDDC_SPI
+ifneq ($(TARGET_OS), Android)
 ifeq ($(CONFIG_LINUX_SPI), yes)
 UNSUPPORTED_FEATURES += CONFIG_LINUX_SPI=yes
 else
@@ -352,6 +354,7 @@
 UNSUPPORTED_FEATURES += CONFIG_MSTARDDC_SPI=yes
 else
 override CONFIG_MSTARDDC_SPI = no
+endif
 endif
 endif
 
@@ -365,6 +368,3 @@
 endif
 
 ###############################################################################
-# General architecture-specific settings.
-# Like above for the OS, below we verify user-supplied options depending on the target architecture.
-
