=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: flashrom
 Section: electronics
-Priority: extra
-Maintainer: Uwe Hermann <uwe@debian.org>
-Build-Depends: cdbs, debhelper (>= 9.0.0), pkg-config, libpci-dev, libusb-dev [!kfreebsd-any], libusb-1.0-0-dev [!hurd-i386], libftdi1-dev [!hurd-i386]
-Standards-Version: 3.9.7
+Priority: optional
+Maintainer: Gürkan Myczko <gurkan@phys.ethz.ch>
+Build-Depends: cdbs, debhelper (>= 10), pkg-config, libpci-dev, libusb-dev [!kfreebsd-any], libusb-1.0-0-dev [!hurd-i386], libftdi1-dev [!hurd-i386]
+Standards-Version: 4.2.1
 Homepage: http://www.flashrom.org
 
 Package: flashrom
