## flashrom 1.0.1

=== Makefile ===
--- 
+++ 
@@ -63,7 +63,7 @@
 WARNERROR ?= yes
 
 ifeq ($(WARNERROR), yes)
-CFLAGS += -Werror
+CFLAGS += -Werror -Wno-error=deprecated-declarations
 endif
 
 ifdef LIBS_BASE
@@ -367,4 +367,3 @@
 endif
 endif
 
-###############################################################################
