=== debian/rules ===
--- 
+++ 
@@ -20,4 +20,3 @@
 	rm -f debian/flashrom.udev
 
 common-binary-post-install-arch:: list-missing
-
